package com.parhamdata.aliza.dto;

import java.util.ArrayList;
import java.util.Collection;

import com.google.gson.GsonBuilder;

public class RequestDto {

    private String model = "gpt-3.5-turbo"; // default model
    private ArrayList<Message> messages = new ArrayList<Message>();
    private double temperature = 0.0;       // default temperature

    public RequestDto() {
    }

    public RequestDto(ArrayList<Message> messages, String model, double temperature) {
        this.model = model;
        this.messages = messages;
        this.temperature = temperature;
    }

    public RequestDto(ArrayList<Message> messages, String model) {
        this.model = model;
        this.messages = messages;
    }

    public RequestDto(ArrayList<Message> messages ) {
        this.messages = messages;
    }

    public RequestDto(Message message, String model, double temperature) {
        this.model = model;
        this.messages.add(message);
        this.temperature = temperature;
    }

    public RequestDto(Message message, String model) {
        this.model = model;
        this.messages.add(message);
    }

    public RequestDto(String message, String model, Double temperature) {
        this.model = model;
        this.messages.add(new Message(message));
        this.temperature = temperature;
    }

    public RequestDto(String message, String model) {
        this.model = model;
        this.messages.add(new Message(message));
    }

    public RequestDto(Message message) {
        this.messages.add(message);
    }

    public RequestDto(String message) {
        this.messages.add(new Message(message));
    }
  
    public String getModel() {
        return this.model;
    }

    public void setModel(String model) {
        this.model = model;
    }

    public ArrayList<Message> getMessages() {
        return new ArrayList<Message>(messages);
    }

    public void setMessages(ArrayList<Message> messages) {
        this.messages = messages;
    }

    public void addMessage(Message message) {
        this.messages.add(message);
    }

    public void addMessages(Collection<Message> messages) {
        this.messages.addAll(messages);
    }

    public double getTemperature() {
        return this.temperature;
    }

    public void setTemperature(double temperature) {
        this.temperature = temperature;
    }

    @Override
    public String toString() {
        return new GsonBuilder().setPrettyPrinting()
                                .create()
                                .toJson(this);
    }

}
